<#ibiztemplate>
TARGET=PSSUBSYSSERVICEAPIDE
</#ibiztemplate>
package ${pub.getPKGCodeName()}.client.${item.getPSSubSysServiceAPI().codeName?lower_case}.service;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.extern.slf4j.Slf4j;

import feign.Client;
import feign.Contract;
import feign.Feign;
import feign.codec.Decoder;
import feign.codec.Encoder;

import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import ${pub.getPKGCodeName()}.core.client.model.I${item.codeName};
import ${pub.getPKGCodeName()}.client.${item.getPSSubSysServiceAPI().getCodeName()?lower_case}.config.${item.getPSSubSysServiceAPI().getCodeName()}ClientProperties;
import ${pub.getPKGCodeName()}.core.client.service.I${item.getCodeName()}ClientService;
import ${pub.getPKGCodeName()}.client.${item.getPSSubSysServiceAPI().codeName?lower_case}.model.${item.codeName}Impl;
import ${pub.getPKGCodeName()}.client.${item.getPSSubSysServiceAPI().codeName?lower_case}.feign.${item.codeName}FeignClient;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.cloud.openfeign.ribbon.LoadBalancerFeignClient;
import ${pub.getPKGCodeName()}.util.feign.FeignRequestInterceptor;
import ${pub.getPKGCodeName()}.util.SearchContext;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import ${pub.getPKGCodeName()}.util.feign.suport.SearchContextFeignEncode;
import ${pub.getPKGCodeName()}.util.log.IBIZLog;

/**
 * 实体[${item.codeName}] 服务对象接口
 */
@Slf4j
@IBIZLog
@Service
public class ${item.codeName}ClientServiceImpl implements I${item.getCodeName()}ClientService {

    ${item.codeName}FeignClient ${item.codeName?uncap_first}FeignClient;

    <#assign subApi=item.getPSSubSysServiceAPI()>
    <#assign servicePath=''>
    <#if subApi.getServiceParam()?? && subApi.getServiceParam()!=''>
        <#assign servicePath='http://'+subApi.getServiceParam()+'/'>
    <#elseif subApi.getServicePath()?? && subApi.getServicePath()!=''>
        <#assign servicePath=subApi.getServiceParam()>
    </#if>
    <#--  <#if servicePath?? && servicePath!=''>  -->
    @Autowired
    public ${item.codeName}ClientServiceImpl(Decoder decoder, Encoder encoder, Client client, Contract contract ,FeignRequestInterceptor feignRequestInterceptor,${item.getPSSubSysServiceAPI().getCodeName()}ClientProperties ${item.getPSSubSysServiceAPI().getCodeName()?lower_case}ClientProperties) {
        if (${item.getPSSubSysServiceAPI().getCodeName()?lower_case}ClientProperties.getServiceId()!=null) {
    		Feign.Builder nameBuilder = Feign.builder()
                    .client(client)
                    .encoder(new SearchContextFeignEncode(encoder))
                    .decoder(decoder)
                    .contract(contract)
                    .requestInterceptor(feignRequestInterceptor)
                    ;
        	this.${item.codeName?uncap_first}FeignClient = nameBuilder.target(${item.getCodeName()}FeignClient.class,"http://"+${item.getPSSubSysServiceAPI().getCodeName()?lower_case}ClientProperties.getServiceId()+"/") ;
		}else if (${item.getPSSubSysServiceAPI().getCodeName()?lower_case}ClientProperties.getServiceUrl()!=null) {
			if (client instanceof LoadBalancerFeignClient) {
				client = ((LoadBalancerFeignClient) client).getDelegate();
			}
			Feign.Builder nameBuilder = Feign.builder()
                    .client(client)
                    .encoder(new SearchContextFeignEncode(encoder))
                    .decoder(decoder)
                    .contract(contract)
                    .requestInterceptor(feignRequestInterceptor)
                    ;
        	this.${item.codeName?uncap_first}FeignClient = nameBuilder.target(${item.getCodeName()}FeignClient.class,"http://"+${item.getPSSubSysServiceAPI().getCodeName()?lower_case}ClientProperties.getServiceUrl()+"/") ;
		}
    }
    <#--  </#if>  -->
    @Override
    public I${item.getCodeName()} createModel() {
		return new ${item.getCodeName()}Impl();
	}


<#if item.getPSSubSysServiceAPIDEMethods()??>
    <#list item.getPSSubSysServiceAPIDEMethods() as apiMethod>
        <#assign req_param_type=(apiMethod.getRequestParamType()!'')>
        <#assign req_param=(apiMethod.getRequestField()!'')>
        <#assign retval_type=(apiMethod.getRetvalType())!''>
        <#assign return_type='void'>
        <#if return_type?? && return_type!='' && retval_type !='VOID' && retval_type='ENTITY' ><#comment>由于无法获取到返回值类型，暂时通过请求参数类型确定返回值类型</#comment>
            <#assign return_type=item.codeName>
        </#if>
        <#if apiMethod.getActionType()=='DEACTION'><#comment>实体行为</#comment>
        <#--  public ${return_type} ${srfmethodname(apiMethod.getCodeName())}(<#if req_param_type?? && req_param_type=='ENTITY'><#if apiMethod.getPSDEName()??>${apiMethod.getPSDEName()} entity</#if></#if>);  -->
    public void ${apiMethod.getCodeName()?uncap_first}(<#if apiMethod.getCodeName()=="CreateBatch" || apiMethod.getCodeName()=="UpdateBatch" || apiMethod.getCodeName()=="RemoveBatch" >List<I${item.codeName}> ${srfpluralize(item.codeName?lower_case)}<#else>I${item.codeName} ${item.codeName?lower_case}</#if>){
        <#if apiMethod.getCodeName() == 'Get'>
        I${item.codeName} clientModel = ${item.codeName?uncap_first}FeignClient.${apiMethod.getCodeName()?uncap_first}(${item.codeName?lower_case}.get${item.getKeyDEField().getCodeName()?cap_first}()) ;
        BeanCopier copier=BeanCopier.create(clientModel.getClass(), ${item.codeName?lower_case}.getClass(), false);
        copier.copy(clientModel, ${item.codeName?lower_case}, null);
        <#elseif apiMethod.getCodeName() == 'Remove'>
        ${item.codeName?uncap_first}FeignClient.${apiMethod.getCodeName()?uncap_first}(${item.codeName?lower_case}.get${item.getKeyDEField().getCodeName()?cap_first}()) ;
        <#elseif apiMethod.getCodeName() == 'Create'>
        I${item.codeName} clientModel = ${item.codeName?uncap_first}FeignClient.${apiMethod.getCodeName()?uncap_first}((${item.codeName}Impl)${item.codeName?lower_case}) ;
        BeanCopier copier=BeanCopier.create(clientModel.getClass(), ${item.codeName?lower_case}.getClass(), false);
        copier.copy(clientModel, ${item.codeName?lower_case}, null);
        <#elseif apiMethod.getCodeName() == 'Update'>
        I${item.codeName} clientModel = ${item.codeName?uncap_first}FeignClient.${apiMethod.getCodeName()?uncap_first}(${item.codeName?lower_case}.get${item.getKeyDEField().getCodeName()?cap_first}(),(${item.codeName}Impl)${item.codeName?lower_case}) ;
        BeanCopier copier=BeanCopier.create(clientModel.getClass(), ${item.codeName?lower_case}.getClass(), false);
        copier.copy(clientModel, ${item.codeName?lower_case}, null);
        <#elseif apiMethod.getCodeName() == 'CreateBatch'>
        if(${srfpluralize(item.codeName?lower_case)}!=null){
            List<${item.codeName}Impl> list = new ArrayList<${item.codeName}Impl>();
            for(I${item.codeName} i${item.codeName?lower_case} :${srfpluralize(item.codeName?lower_case)}){
                list.add((${item.codeName}Impl)i${item.codeName?lower_case}) ;
            }
            ${item.codeName?uncap_first}FeignClient.${apiMethod.getCodeName()?uncap_first}(list) ;
        }
        <#elseif apiMethod.getCodeName() == 'UpdateBatch'>
        if(${srfpluralize(item.codeName?lower_case)}!=null){
            List<${item.codeName}Impl> list = new ArrayList<${item.codeName}Impl>();
            for(I${item.codeName} i${item.codeName?lower_case} :${srfpluralize(item.codeName?lower_case)}){
                list.add((${item.codeName}Impl)i${item.codeName?lower_case}) ;
            }
            ${item.codeName?uncap_first}FeignClient.${apiMethod.getCodeName()?uncap_first}(list) ;
        }
        <#elseif apiMethod.getCodeName() == 'RemoveBatch'>
        if(${srfpluralize(item.codeName?lower_case)}!=null){
            List<${item.codeName}Impl> list = new ArrayList<${item.codeName}Impl>();
            for(I${item.codeName} i${item.codeName?lower_case} :${srfpluralize(item.codeName?lower_case)}){
                list.add((${item.codeName}Impl)i${item.codeName?lower_case}) ;
            }
            ${item.codeName?uncap_first}FeignClient.${apiMethod.getCodeName()?uncap_first}(list) ;
        }
        <#else>
        I${item.codeName} clientModel = ${item.codeName?uncap_first}FeignClient.${apiMethod.getCodeName()?uncap_first}(${item.codeName?lower_case}.get${item.getKeyDEField().getCodeName()?cap_first}(),(${item.codeName}Impl)${item.codeName?lower_case}) ;
        BeanCopier copier=BeanCopier.create(clientModel.getClass(), ${item.codeName?lower_case}.getClass(), false);
        copier.copy(clientModel, ${item.codeName?lower_case}, null);
        </#if>
    }

        <#elseif apiMethod.getActionType()=='SELECT'><#comment>简单查询</#comment>
        <#--  public List<${item.codeName}> ${srfmethodname(apiMethod.getCodeName())}(<#if req_param_type?? && req_param_type=='ENTITY'><#if apiMethod.getPSDEName()??>${apiMethod.getPSDEName()} entity</#if></#if>);  -->
    public Page<I${item.codeName}> ${apiMethod.getCodeName()?uncap_first}(SearchContext context){
        return null ;
    }

        <#elseif apiMethod.getActionType()=='FETCH'><#comment>数据集合</#comment>
    public Page<I${item.codeName}> ${apiMethod.getCodeName()?uncap_first}(SearchContext context){
        Page<${item.codeName}Impl> page = this.${item.codeName?uncap_first}FeignClient.${apiMethod.getCodeName()?uncap_first}(context) ;
        return new PageImpl(page.getContent(),context.getPageable(),page.getTotalElements());
    }

        <#elseif apiMethod.getActionType()=='USER'><#comment>用户自定义</#comment>
    public void ${apiMethod.getCodeName()?uncap_first}(){

    }
        </#if>

    </#list>
</#if>

}

